<?php

/**
 * Mini SQL - A plugin that provide a page for querying your MyBB database
 *  
 * License: GNU GPLv3
 */
 
$plugins->add_hook('admin_tools_menu', 'mini_sql_tools');
$plugins->add_hook('admin_tools_action_handler', 'mini_sql_action_handler');
$plugins->add_hook('admin_config_menu', 'mini_sql_config');
$plugins->add_hook('admin_config_action_handler', 'mini_sql_config_action_handler');

/**
 * Function which describe plugin information
 *
 * @return array
 */
function mini_sql_info() {
   return array(
		"name"			=> "Mini SQL",
		"description"	=> "A plugin that provide a page for querying your MyBB database",
		"website"		=> "http://rioastamal.net/mybb/mini-sql/",
		"author"		   => "Rio Astamal",
		"authorsite"	=> "http://rioastamal.net/",
		"version"		=> "1.0",
		"guid" 			=> "074c16d6f7f2c3ccbe75b189a5e98597", 
		"compatibility" => "14*"
   );
}

/**
 * ADDITIONAL PLUGIN INSTALL/UNINSTALL ROUTINES
 *
 * _install():
 *   Called whenever a plugin is installed by clicking the "Install" button in the plugin manager.
 *   If no install routine exists, the install button is not shown and it assumed any work will be
 *   performed in the _activate() routine.
 *
 * function hello_install()
 * {
 * }
 *
 * _is_installed():
 *   Called on the plugin management page to establish if a plugin is already installed or not.
 *   This should return TRUE if the plugin is installed (by checking tables, fields etc) or FALSE
 *   if the plugin is not installed.
 *
 * function hello_is_installed()
 * {
 *		global $db;
 *		if($db->table_exists("hello_world"))
 *  	{
 *  		return true;
 *		}
 *		return false;
 * }
 *
 * _uninstall():
 *    Called whenever a plugin is to be uninstalled. This should remove ALL traces of the plugin
 *    from the installation (tables etc). If it does not exist, uninstall button is not shown.
 *
 * function hello_uninstall()
 * {
 * }
 *
 * _activate():
 *    Called whenever a plugin is activated via the Admin CP. This should essentially make a plugin
 *    "visible" by adding templates/template changes, language changes etc.
 *
 * function hello_activate()
 * {
 * }
 *
 * _deactivate():
 *    Called whenever a plugin is deactivated. This should essentially "hide" the plugin from view
 *    by removing templates/template changes etc. It should not, however, remove any information
 *    such as tables, fields etc - that should be handled by an _uninstall routine. When a plugin is
 *    uninstalled, this routine will also be called before _uninstall() if the plugin is active.
 *
 * function hello_deactivate()
 * {
 * }
 */
 
function mini_sql_activate() { 
   global $db;
   
   // insert setting
   $mini_sql_settings = array(
		'name' => 'mini_sql_config',
		'title' => 'Config Mini SQL',
		'description' => '<label>Separate using space i.e: <strong>DROP GRANT DELETE REVOKE</strong></label>.',
		'optionscode' => 'text',
		'value' => 'DELETE DROP GRANT REVOKE',
		'disporder' => 1,
		'gid' => 17 // Server
   );
   $db->insert_query("settings", $mini_sql_settings);
}

function mini_sql_deactivate() { 
   global $db;
   
   $db->delete_query('settings', "name='mini_sql_config'");
}

function mini_sql_config($ref) {
   $ref[] = array("id" => "mini_sql", "title" => 'Mini SQL', "link" => "index.php?module=config/mini_sql");
}

function mini_sql_config_action_handler($ref) {
   // I know this is may not good :)
   define('MINI_SQL_CONFIG_FILE', '../../../inc/plugins/mini_sql/mini_sql_config.php');
   $ref['mini_sql'] = array('active' => 'mini_sql', 'file' => MINI_SQL_CONFIG_FILE);
}

function mini_sql_tools($ref) {
   $ref[] = array("id" => "mini_sql", "title" => 'Mini SQL', "link" => "index.php?module=tools/mini_sql");
}

function mini_sql_action_handler($ref) {
   // I know this is may not good :)
   define('MINI_SQL_FILE', '../../../inc/plugins/mini_sql/mini_sql.php');
   $ref['mini_sql'] = array('active' => 'mini_sql', 'file' => MINI_SQL_FILE);
}

function mini_sql_get_data() {
   global $db;
   
   $query = $db->query("SELECT value FROM " . TABLE_PREFIX . "settings WHERE name='mini_sql_config' LIMIT 1");
   $data = $db->fetch_array($query);
   
   return $data['value'];
}


?>
