<?php

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

$page->add_breadcrumb_item("Mini SQL", "index.php?module=tools/mini_sql");
$page->output_header('Mini SQL Query Page');

$mini_sql_info = mini_sql_info();
$forbidden_clause = explode(' ', mini_sql_get_data());

if(!$mybb->input['action']) {

   $curpost = '';
   
   if ($mybb->request_method == "post") {
      if (mini_sql_is_forbidden($_POST['sql'])) {
         flash_message('Sorry you have entered one or more forbidden clause.', 'error');
         admin_redirect("index.php?module=tools/mini_sql"); 
         die(); 
      }
      $curpost = $_POST['sql'];
   }
   if ($curpost == '') $curpost = 'SELECT * FROM `' . TABLE_PREFIX . 'users` LIMIT 10';

   $form = new Form("index.php?module=tools/mini_sql", "post", "mini_sql", 0, "mini_query");
      
      $table = new Table;
      $table->construct_header('Execute SQL Query', array('colspan' => 2));
      $table->construct_cell('Forbidden clause are <span style="color:#c60000;font-weight:bold;">' . implode(', ', $forbidden_clause) . '</span>.');
      $table->construct_cell('List of Table(s)');
      $table->construct_row();
      $table->construct_cell('<textarea name="sql" id="sql" style="width:500px;height:200px">' . $curpost . '</textarea>');

      $option = '';
      $table_list = $db->list_tables($config['database']['database']);
      foreach ($table_list as $t) {
         $option .= '<option value="'. $t . '">' . $t . "\n";
      }
      
      $table->construct_cell('<select ondblclick="op_win(this.value);" name="curtable" size="12">' . $option . '</select><br /><span>Double click to show the columns</span>');
    	$table->construct_row();
      $table->output('Query Page - Mini SQL v' . $mini_sql_info['version']. ' | <a href="index.php?module=config/mini_sql" title="Go to option page">Setting &raquo;</a>');
      
      $buttons[] = $form->generate_submit_button('Execute Query');
      $form->output_submit_wrapper($buttons);

   $form->end();
   
   ?>
      <script language="javascript">
         function op_win(tabname) {
            // var colwin = window.open('<?php echo DEMA_BASE_URL.$_SERVER['REQUEST_URI'];?>&col='+colname, 'colwin', 'scrollbars=1,toolbar=0,left=20,top=50,width=500,height=500');
            // colwin.focus();
            var sql = document.getElementById('sql');
            sql.innerHTML = 'SHOW COLUMNS FROM `'+tabname+'`;';
         }
      </script>
	<?php
	if ($mybb->request_method == 'post') {
	   echo '<br />';
	   $query = $db->query($curpost);
	   $fields = mini_sql_generate_fields($query);
	   
	   $table = new Table;
	   
	   foreach ($fields as $f) {
	      $table->construct_header($f);
	   }
	   
	   while ( $data = $db->fetch_array($query) ) {
	      foreach ($data as $val) {
	         $table->construct_cell($val);
         }
   	   $table->construct_row();
	   }
	   
	   $table->output('Query Results - Mini SQL');
	}
	
   $page->output_footer();
}

function mini_sql_is_forbidden($clause) {
   global $forbidden_clause;
   $forbid = implode('|', $forbidden_clause);
   if (preg_match('/\b(' . $forbid . ')\b/i', $clause)) {
      return TRUE;
   }
   return FALSE;
}

function mini_sql_generate_fields($res) {
   $total = mysql_num_fields($res);
   // echo "TOTAL: $total";
   
   $fields = array();
   for ($i=0; $i<$total; $i++) {
      $fields[] = mysql_field_name($res, $i);
   }
   return $fields;
}

/**
 * Unused function maybe for future :)
 * 
function mini_sql_get_table($query) {
   $is_select = FALSE;
   $table = '';
   if (preg_match('/\bSELECT\b/i', $query)) {
      $is_select = TRUE;
   }
   if ($is_select) {
      preg_match('/SELECT\s[a-zA-Z*]\sFROM\s([a-zA-Z`_]+)/i', $query, $matches);
      $table = $matches[1];
   } else {
      preg_match('/UPDATE\s([a-zA-Z_`]+)\s/i', $query, $matches);
      $table = $matches[1];
      // print_r($matches);
   }
   return $table;
}
*/

?>
